      program filter
C
c  Filter program to read initial FrameMaker HTML file
c  and split it into distinct files for each command.
c  The <h1> header is the key phrase.
c
c  As a side effect, break long lines into lines with no more than
c  72 characters.
c
      character*5000 ia1
      character*256 ia2
      character*80 fname
c
      read(*,'(a80)')ia1
      write(*,'(a)')ia1(1:25)
      nfile=0
      nopen=0
      nout=10
      maxchr=5000
C
 10   continue
        ia1=' '
        ia2=' '
        read(*,'(a)',end=9999)ia1
        if(ia1(1:4).eq.'<h1>')then
          do100i=80,5,-1
            if(ia1(i-4:i).eq.'</h1>')then
              if(nopen.eq.1) close(nout)
              nchars=(i-5)-5
              fname=' '
              fname(1:nchars)=ia1(6:i-5)
              fname(nchars+1:nchars+5)='.html'
              do110j=1,nchars+1
                itemp=ichar(fname(j:j))
                if(fname(j:j).eq.' ')then
                  fname(j:j)='_'
                elseif(itemp.ge.65 .and. itemp.le.91) then
                  fname(j:j)=char(itemp+32)
                endif
 110          continue
              open(unit=nout,file=fname)
              nopen=1
              nfile=nfile+1
              write(nout,'(a)') ia1(1:i)
              goto10
            endif
 100      continue
          print *,'Unmatched <h1>'
          stop
        end if
        if(ia1(1:8).eq.'<a name=')goto10
        if(ia1(1:4).eq.'</a>')goto10
        if(nfile.eq.0)goto10
        do200i=maxchr,1,-1
          if(ia1(i:i).ne.' ')then
            nlast=i
            goto209
          endif
 200    continue
        goto10
 209    continue
c
        if(nlast.le.72)then
          write(nout,'(a)') ia1(1:nlast)
        else
          nfirst=1
 300      continue
          nstop=nfirst+65
          do310j=nstop,nstop+100,1
            if(ia1(j:j).eq.' ')then
              nstop=j
              write(nout,'(a)') ia1(nfirst:nstop)
              nfirst=nstop+1
              if(nfirst.gt.nlast)goto10
              goto300
            endif
 310      continue
        endif
c
      goto 10
c
 9999 continue
      stop
      end
